<?php 
/*
Plugin Name: Post to speech
Plugin URI: http://aleph.llull.net/post-to-speech/
Description: Uses Festival Text-to-speech an some encoding tools (LAME and oggenc) to encode the post in a MP3/Ogg Vorbis audio file.
Version: 0.4
Author: Eduard Llull
Author URI: http://aleph.llull.net/
*/ 
/*  Copyright 2005  Eduard Llull Pou  (email : eduard@llull.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require_once('loadoptions.php');

function post2speech_post_edit($id)
{
	global $wpdb;
	global $post2speech_options;

	if(!isset($id)) $id = $_REQUEST['post_ID'];

	if(isset($_REQUEST['post2speech_delete'])) post2speech_post_delete($id);

	if(!isset($_REQUEST['post2speech_localenabled'])) return;
	
	// Get the post data from database
	$post = $wpdb->get_row("SELECT post_title, post_date, post_content, post_name, post_author FROM {$wpdb->posts} WHERE ID = '{$id}' LIMIT 1");
	$author = $wpdb->get_row("SELECT user_firstname, user_lastname FROM {$wpdb->users} WHERE ID = {$post->post_author}");
	$blogname = get_option('blogname');
	$blogcharset = get_option('blog_charset');

	// Format the data
	$date = mysql2date('d \de\l m \de Y', $post->post_date);
	$year = mysql2date('Y', $post->post_date);

	$text = sprintf('%s. %s. %s', $post->post_title, $date, $post->post_content);
	$text = strip_tags($text);
	$text = html_entity_decode($text, ENT_QUOTES);
	$text = mb_convert_encoding($text, "ISO-8859-1", $blogcharset);
	$text = str_replace('', '', $text);
	$text = str_replace('', '', $text);
	$text = str_replace('"', '', $text);
	$text = str_replace('\'', '', $text);

	$lame_options = sprintf('--ta "%s %s" --tt "%s" --tl "%s" --tg "%s" --ty "%s"',
	                        $author->user_firstname,
				$author->user_lastname,
				$post->post_title,
				$blogname,
				$post2speech_options['genre'],
				$year);
	$lame_input = '-';
	$lame_output = ABSPATH . $post2speech_options['speechdir'] . $id . '.mp3';

	exec("echo '$text' | ${post2speech_options['text2wave']} | lame $lame_options $lame_input $lame_output");
}

function post2speech_post_delete($id)
{
	global $post2speech_options;

	if(!isset($id)) $id = $_REQUEST['post_ID'];

	unlink(ABSPATH . $post2speech_options['speechdir'] . $id . ".mp3");
}

function post2speech_manager()
{
	global $post2speech_options;

	if(isset($_REQUEST['disable'])) $post2speech_options['enabled'] = false;
	if(isset($_REQUEST['enable'])) $post2speech_options['enabled'] = true;
	if($_REQUEST['speechdir']) $post2speech_options['speechdir'] = $_REQUEST['speechdir'];
	if($_REQUEST['genre']) $post2speech_options['genre'] = $_REQUEST['genre'];
	if($_REQUEST['speech_permalink']) {
		$post2speech_options['speech_permalink'] = $_REQUEST['speech_permalink'];
		$update_permalinks_msg = '<strong>Remember to <a href="options-permalink.php">update your permalinks</a>.</strong>';
	}
	update_option('post2speech_options', $post2speech_options);

	echo '<div class="wrap">';
	echo '<h2>Post-to-Speech Manager</h2>';

	// Check for installation
	exec('festival --help', $output, $ret);
	if($ret)
		$error .= '<li><strong>Error:</strong> Festival is not installed. Please, install it.</li>';
	exec('lame --help', $output, $ret);
	if($ret)
		$error .= '<li><strong>Error:</strong> Lame is not installed. Please, install it.</li>';
	if(!file_exists($post2speech_options['text2wave']))
		$error .= '<li><strong>Error:</strong> Check that the ' . $post2speech_options['text2wave'] . ' script exists.</li>';
	if(!file_exists(ABSPATH . $post2speech_options['speechdir']) && !mkdir(ABSPATH . $post2speech_options['speechdir'], 0777))
			$error .= '<li><strong>Error:</strong> The speech directory ' . $post2speech_options['speechdir'] . ' did not exist and could not be created.</li>';
	
	if($error) {
		echo 'The following errors have been detected:';
		echo '<ul>';
		echo $error;
		echo '</ul>';
	}
	else {
		echo '<fieldset class="options"><legend>Main options</legend>';
		echo '<form name="post2speech" action="'. $_SERVER["REQUEST_URI"] . '" method="post">';
		if(post2speech_is_global_enabled()) {
			echo '<strong>Post-to-Speech is globaly enabled.</strong>';
			echo '<input type="hidden" name="disable" />';
			echo '<div class="submit"><input type="submit"value="Disable it" /></div>';
		}
		else {
			echo '<strong>Post-to-Speech is globaly disabled.</strong>';
			echo '<input type="hidden" name="enable" />';
			echo '<div class="submit"><input type="submit"value="Enable it" /></div>';
		}
		echo '</form>';
		echo '</fieldset>';

		echo '<fieldset class="options"><legend>Path options</legend>';
		echo '<form name="post2speech" action="'. $_SERVER["REQUEST_URI"] . '" method="post">';
		echo '<label for="speechdir">Relative path to speech files:</label><br />';
		echo '<input type="text" name="speechdir" value="' . $post2speech_options['speechdir'] . '" /><br />';
		echo '<br />';
		echo '<label for="speech_permalink">Permalink prefix for speech files (the links will be "<em>prefix</em>/<em>post-name</em>.mp3"):</label><br />';
		echo '<input type="text" name="speech_permalink" value="' . $post2speech_options['speech_permalink'] . '" />' . $update_permalinks_msg . '<br />';
		echo '<div class="submit"><input type="submit" value="Apply changes" /></div>';
		echo '</form>';
		echo '</fieldset>';

		echo '<fieldset class="options"><legend>ID3 tags options</legend>';
		echo '<form name="post2speech" action="'. $_SERVER["REQUEST_URI"] . '" method="post">';
		echo '<label for="genre">ID3 tag genre</label><br/ >';
		echo '<input type="text" name="genre" value="' . $post2speech_options['genre'] . '" /></li>';
		echo '<div class="submit"><input type="submit" value="Apply changes" /></div>';
		echo '</form>';
		echo '</fieldset>';
	}
	echo '</div>';
}

function post2speech_edit_post_form($not_used)
/**
 * Displays the enable checkbutton interface on the post editing form
 *
 * Long description for the Function.
 *
 * @param        $not_used       Description
 */
{
	global $postdata, $post2speech_options;

	if (post2speech_is_global_enabled()) $checked = 'checked="checked" ';

	echo '<fieldset><legend><a href="http://aleph.llull.net/post-to-speech/">Post-to-Speech</a></legend>';
	echo '<label for="post2speech_localenabled" style="float: right;"><input type="checkbox" name="post2speech_localenabled" value="enabled" ' . $checked . '/> Generate speech file</label><br />';
	if(post2speech_post_has_speech($postdata->ID))
		echo '<label for="post2speech_delete" style="float: right;"><input type="checkbox" name="post2speech_delete" value="enabled" /> Delete speech file (Save the post to delete it)</label><br />';
	echo '</fieldset>';
}

function post2speech_is_global_enabled()
{
	global $post2speech_options;
	return $post2speech_options['enabled'];
}

function post2speech_post_has_speech($id)
{
	global $post2speech_options;
	
	return is_readable(ABSPATH . $post2speech_options['speechdir'] . $id . '.mp3');
}

function post2speech_link($link = 'speech', $before = '', $after = '')
{
	global $post, $wp_rewrite, $post2speech_options;

	$filename = $post2speech_options['speechdir'] . $post->ID . '.mp3';
	if (! $wp_rewrite->using_mod_rewrite_permalinks())
		$href = $filename;
	else
		$href = $post2speech_options['speech_permalink'] . $post->post_name . '.mp3';

	if(post2speech_post_has_speech($post->ID))
		echo "$before <a href=\"$href\">$link</a> $after";
}

function post2speech_create_rewrite_rules($wp_rewrite)
{
	global $post2speech_options;
	$post2speech_rules = array (
		$post2speech_options['speech_permalink'] . '(.+).mp3' => 'wp-content/plugins/post2speech/speechbypostname.php?name=' . $wp_rewrite->preg_index(1)
	);
	$wp_rewrite->rules = $wp_rewrite->rules + $post2speech_rules;
}

function post2speech_add_page()
{
	add_options_page('Post-to-Speech Manager', 'Post2Speech', 5, __FILE__, 'post2speech_manager');
}

add_action('edit_form_advanced', 'post2speech_edit_post_form');
add_action('edit_post', 'post2speech_post_edit');
add_action('delete_post', 'post2speech_post_delete');
add_action('admin_menu', 'post2speech_add_page');
add_filter('generate_rewrite_rules', 'post2speech_create_rewrite_rules');
?>
